diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index 3e83f375b5..4a63590045 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -12868,13 +12868,16 @@ RememberReplicaIdentityForRebuilding(Oid indoid, AlteredTableInfo *tab)
 static void
 RememberClusterOnForRebuilding(Oid indoid, AlteredTableInfo *tab)
 {
+	char	*indname;
+
 	if (!get_index_isclustered(indoid))
 		return;
 
-	if (tab->clusterOnIndex)
+	indname = get_rel_name(indoid);
+	if (tab->clusterOnIndex && strcmp(tab->clusterOnIndex, indname) != 0)
 		elog(ERROR, "relation %u has multiple clustered indexes", tab->relid);
 
-	tab->clusterOnIndex = get_rel_name(indoid);
+	tab->clusterOnIndex = indname;
 }
 
 /*
